"use strict";

var t = require('@babel/types');

var parse = require('./parse');

var traverse = require('./traverse');

var getDefaultExportedPath = require('./getDefaultExportedPath');

var convertAstExpressionToVariable = require('./convertAstExpressionToVariable');

var historyMemory = {
  hash: 'createHashHistory',
  memory: 'createMemoryHistory',
  browser: 'createBrowserHistory'
};
/**
 * Universal App Shell Loader for Rax.
 */

module.exports = function (content) {
  if (this.data.appConfig !== null) {
    var _this$data$appConfig = this.data.appConfig,
        _this$data$appConfig$ = _this$data$appConfig.pages,
        pages = _this$data$appConfig$ === void 0 ? [] : _this$data$appConfig$,
        _this$data$appConfig$2 = _this$data$appConfig.historyType,
        historyType = _this$data$appConfig$2 === void 0 ? 'hash' : _this$data$appConfig$2;
    var requestPages = pages.map(function (pagePath, index) {
      return "import Page" + index + " from './" + pagePath + "';";
    }).join('\n');
    var source = "\n      import App from '" + this.resourcePath + "';\n      import { render, createElement } from 'rax';\n      import { useRouter } from 'rax-use-router';\n      import { " + historyMemory[historyType] + " as createHistory } from 'history';\n      import DriverUniversal from 'driver-universal/src/index';\n      " + requestPages + "\n      \n      const appInstance = new App();\n      const getRouteConfig = () => {\n        const routes = [];\n        " + assembly + "\n        // [\n        //     {\n        //       path: '',\n        //       routes: [\n        //         {\n        //           path: '',\n        //           component: () => createElement(Page0, { app: appInstance }),\n        //         },\n        //       ],\n        //     }\n        //   ]\n        return {\n          history: createHistory(),\n          routes,\n        };\n      };\n      \n      function Entry() {\n        const { component } = useRouter(getRouteConfig);\n        return component;\n      }\n\n      render(createElement(Entry), null, { driver: DriverUniversal });\n    ";
    return source;
  } else {
    return content;
  }
};

module.exports.pitch = function (remainingRequest, precedingRequest, data) {
  data.appConfig = null; // Provide default value.

  var rawContent = this.fs.readFileSync(this.resource).toString();
  var ast = parse(rawContent);
  var defaultExportedPath = getDefaultExportedPath(ast);

  if (defaultExportedPath) {
    traverse(defaultExportedPath, {
      ClassProperty: function ClassProperty(path) {
        var node = path.node;

        if (node.static && t.isIdentifier(node.key, {
          name: 'config'
        })) {
          data.appConfig = convertAstExpressionToVariable(node.value);
        }
      }
    });
  }
};